package com.ruoyi.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.bean.BeanUtils;
import com.ruoyi.domain.Standard;
import com.ruoyi.domain.StandardInspectionItemRelation;
import com.ruoyi.domain.vo.DictDataVO;
import com.ruoyi.mapper.StandardInspectionItemRelationMapper;
import com.ruoyi.mapper.StandardMapper;
import com.ruoyi.service.StandardInspectionItemRelationService;
import com.ruoyi.service.StandardService;
import com.ruoyi.web.request.StandardEditRequest;
import com.ruoyi.web.request.StandardGetInfoRequest;
import com.ruoyi.web.request.StandardListRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.web.response.StandardResponse;

import java.util.ArrayList;
import java.util.List;

@Service
public class StandardServiceImpl extends ServiceImpl<StandardMapper, Standard> implements StandardService {

    @Autowired
    private StandardMapper standardMapper;

    @Autowired
    private StandardService standardService;

    @Autowired
    private StandardInspectionItemRelationMapper standardInspectionItemRelationMapper;

    @Autowired
    private StandardInspectionItemRelationService standardInspectionItemRelationService;

    /**
     * 分页查询
     * @param
     * @return
     */
    @Override
    public List<Standard> findList(StandardListRequest request) {
        return standardMapper.findList(request);
    }

    /**
     * 根据id查询
     * @param id
     * @return
     */
    @Override
    public Standard findListById(Long id) {
        return standardMapper.findListById(id);
    }

    @Override
    public void editStandard(StandardEditRequest request) {

        Standard standard = new Standard();
        BeanUtils.copyBeanProp(standard, request);

        List<StandardInspectionItemRelation> list = standardInspectionItemRelationMapper.getListByStandard(request.getId());

        if (list != null && list.size() != 0) {
            standardInspectionItemRelationService.removeBatchByIds(list);
        }

        List<DictDataVO> relations = request.getDictList();
        List<StandardInspectionItemRelation> relationList = new ArrayList<>();

        if (relations != null && relations.size() != 0) {
            for (DictDataVO vo : relations) {
                StandardInspectionItemRelation relation = new StandardInspectionItemRelation();
                relation.setStandardId(request.getId());
                relation.setDictCode(vo.getDictCode());
                relationList.add(relation);
            }

            standardInspectionItemRelationService.saveBatch(relationList);
        }
        standardService.updateById(standard);
    }

    @Override
    public StandardResponse getInfo(StandardGetInfoRequest request) {
        StandardResponse response = new StandardResponse();
        Standard standard = standardMapper.selectById(request.getId());
        List<DictDataVO> list = standardInspectionItemRelationMapper.getListByStandardId(request.getId());
        BeanUtils.copyBeanProp(response, standard);
        response.setDictList(list);
        return response;
    }

    /**
     * 标准库分页查询(可选用标准列表)
     * @param request
     * @return
     */
    @Override
    public List<Standard> findStandardList(StandardListRequest request) {
        return standardMapper.findStandardList(request);
    }
}
